#include <avr/io.h>
#include <avr/interrupt.h>

#define F_CPU=8000000UL

#define output PORTB//регистр вывода(нужно три первых бита и четвертый как нажатие)

#define buffsize 100

#define ctrl 0x14
#define shift 0x12
#define alt 0x11

unsigned char mybit, mybyte, buffer[buffsize], nb, altkey, shiftkey, ctrlkey, f0;


void delay(unsigned int t){
unsigned char a, j, h;
unsigned int s;
for(s=0; s<t; s++)
	for(j=0; j<10; j++)
		for(h=0; h<100; h++)
			__asm__ __volatile__ ("nop" ::);
}

void write(unsigned char a){

	char j;
	for (j=6; j>=0; j-=3){
		output&=0b11111000;
		output|=((a&(0b111<<j))>>j);
		delay(5);
		output|=0b00001000;
		delay(10);
		output&=0b11110111;
	}
	output&=0b11111000;

	return;
}

ISR(INT0_vect){

	if(mybit<=9){
		unsigned char t_mybyte=mybyte>>1;
		if(PINB & 0b00100000)
			t_mybyte|=0b10000000;
		mybyte=t_mybyte;
	}
	if(mybit==10){
		if(mybyte==0x59)
			mybyte=0x12;
		unsigned char ifok=0;
		buffer[nb]=mybyte;

// Это следит за положением шифта контрла и альта
		if(mybyte==shift){
			if(shiftkey) ifok++;			
			shiftkey=f0;
			if(!shiftkey){
				buffer[nb]=0xf0;
				nb++;
				buffer[nb]=shift;
				nb++;
			}	
		}
		
		if(mybyte==alt){
			if(altkey) ifok++;			
			altkey=f0;
			if(!altkey){
				buffer[nb]=0xf0;
				nb++;
				buffer[nb]=alt;
				nb++;
			}	
		}
		
		if(mybyte==ctrl){
			if(ctrlkey) ifok++;			
			ctrlkey=f0;
			if(!ctrlkey){
				buffer[nb]=0xf0;
				nb++;
				buffer[nb]=ctrl;
				nb++;
			}
		}
		
		if(!f0){
			ifok++;
		}
		f0=mybyte-0xf0;//до сюда включительно

		if(!f0){
			ifok++;
		}
		ifok+=(mybyte==0xe0);
		
		if((!ifok) && (nb<buffsize-4)) nb++;
		mybyte=0;
		mybit=0xff;
	}
	mybit++;
}


int main(void){
	char i=0;

	DDRB=0b11001111;//out_clock, out_data, in_data, пусто, out_click, out_bit3, out_bit2, out_bit1
	PORTB=0b11110000;
	
	EICRA=(1<<ISC01);
	EIMSK=(1<<INT0);

	delay(200);
	mybyte=0;
	mybit=0;
	nb=0;
	altkey=0;
	shiftkey=0;
	ctrlkey=0;
	f0=0;
	
	sei();
	
	write(0xff);
	for(;;){
		if(nb>0){
			write(buffer[0]);
			for(i=1; i<nb; i++){
				buffer[i-1]=buffer[i];
			}
			nb--;
		}
		delay(10);
 	}
	
}



